unit hiDirTools;

interface

uses Kol,Share,Debug,ShellAPI;

type
  THIDirTools = class(TDebug)
   private
   public
    _prop_AllowUnDo:byte;
    _prop_FilesOnly:byte;
    _prop_MultiDestFiles:byte;
    _prop_NoConfirmation:byte;
    _prop_NoConfirmMKDir:byte;
    _prop_NoErrorUI:byte;
    _prop_RenameOnCollision:byte;
    _prop_Silent:byte;
    _prop_SimpleProgress:byte;

    _data_Dest:THI_Event;
    _data_Source:THI_Event;
    _event_onOK:THI_Event;

    function Op(func:cardinal; const FromFolder,ToFolder: string; flags:word):boolean;
    function creatflg():word;
    procedure _work_doCopy(var _Data:TData; Index:word);
    procedure _work_doMove(var _Data:TData; Index:word);
    procedure _work_doDelete(var _Data:TData; Index:word);
    procedure _work_doRename(var _Data:TData; Index:word);
    procedure _work_doExists(var _Data:TData; Index:word);
  end;

implementation

function THIDirTools.Op;
var
  Fo      : TSHFileOpStruct;
  buffer  : array[0..4096] of char;
  p       : pchar;
begin
  FillChar(Buffer, sizeof(Buffer), #0);
  p := @buffer;
  StrPCopy(p, PChar(FromFolder)); //,    
  FillChar(Fo, sizeof(Fo), 0);
  Fo.Wnd    := ReadHandle;
  Fo.wFunc  := func;
  Fo.pFrom  := @Buffer;
  Fo.pTo    := PChar(ToFolder); //   
  Fo.fFlags := flags;
  Result := not (((SHFileOperation(Fo) <> 0) or (Fo.fAnyOperationsAborted <> false)));
end;

function THIDirTools.creatflg():word;
var s:word;
begin
  s:=0;
  if _prop_AllowUnDo=1 then s := s + FOF_ALLOWUNDO;
  if _prop_FilesOnly=1 then s := s + FOF_FILESONLY;
  if _prop_MultiDestFiles=1 then s := s + FOF_MULTIDESTFILES;
  if _prop_NoConfirmation=1 then s := s + FOF_NOCONFIRMATION;
  if _prop_NoConfirmMKDir=1 then s := s + FOF_NOCONFIRMMKDIR;
  if _prop_NoErrorUI=1 then s := s + FOF_NOERRORUI;
  if _prop_RenameOnCollision=1 then s := s + FOF_RENAMEONCOLLISION;
  if _prop_Silent=1 then s := s + FOF_SILENT;
  if _prop_SimpleProgress=1 then s := s + FOF_SIMPLEPROGRESS;
  result := s;
end;

procedure THIDirTools._work_doCopy;
begin
  Op(FO_COPY,ReadString(_Data,_data_Source,''),ReadString(_Data,_data_Dest,''),creatflg());
  _hi_OnEvent(_event_onOK);
end;

procedure THIDirTools._work_doMove;
begin
  Op(FO_MOVE,ReadString(_Data,_data_Source,''),ReadString(_Data,_data_Dest,''),creatflg());
  _hi_OnEvent(_event_onOK);
end;

procedure THIDirTools._work_doDelete;
begin
  Op(FO_DELETE,ReadString(_Data,_data_Source,''),'',creatflg());
  _hi_OnEvent(_event_onOK);
end;

procedure THIDirTools._work_doRename;
begin
  Op(FO_RENAME,ReadString(_Data,_data_Source,''),ReadString(_Data,_data_Dest,''),creatflg());
  _hi_OnEvent(_event_onOK);
end;

procedure THIDirTools._work_doExists;
begin
   if DirectoryExists(ReadString(_Data,_data_Source,'')) then
     _hi_OnEvent(_event_onOK,1)
   else if FileExists(ReadString(_Data,_data_Source,'')) then
      _hi_OnEvent(_event_onOK,1)
   else _hi_OnEvent(_event_onOK,0);
end;

end.
